﻿-- Author      : Nogarder
-- Create Date : 2013/4/7 10:23:43
local NPA_Color_GetColorByFaction=NPA.Color.GetColorByFaction
local NPA_Color_GetColorByClass=NPA.Color.GetColorByClass
local NPA_Color_GetColorByThreat=NPA.Color.GetColorByThreat
local NPA_NamePlateDataParser_AddElements=NPA.NamePlateDataParser.AddElements

local NPA_NamePlateModuleManager_ZipModule=NPA.NamePlateModuleManager.ZipModule
local NPA_NamePlateModuleManager_UnzipModule=NPA.NamePlateModuleManager.UnzipModule

local NPA_DataCollector_GetUnitDataByGUID=NPA.DataCollector.GetUnitDataByGUID

local NPA_FrameMacro_SetFrameTimer=NPA.FrameMacro.SetFrameTimer

local UnitGUID=UnitGUID
--
NPA.NamePlateModuleManager.RegisterDataModule("Text","Target",function(framedata,textframe,setting)
	--add event elements
 	--hook name update
	local colormode=setting.ColorMode
	--
	local ColorFunc
	--
	if(colormode==1)then --color by faction
		ColorFunc=function(text,unitdata)
			local color=NPA_Color_GetColorByFaction(unitdata.Faction)
			text:SetTextColor(color.R,color.G,color.B,color.A)
		end
	elseif(colormode==2)then --color by class
		ColorFunc=function(text,unitdata)
			local color=NPA_Color_GetColorByClass(unitdata.Class,unitdata.Type)
			text:SetTextColor(color.R,color.G,color.B,color.A)
		end
	elseif(colormode==3)then --color by threat
		ColorFunc=function(text,unitdata)
			local color=NPA_Color_GetColorByThreat(unitdata.ThreatStatus)
			text:SetTextColor(color.R,color.G,color.B,color.A)
		end
	else
		ColorFunc=function()
		end
	end
	--
	local You="=>>!!You!!<<="
	NPA_NamePlateDataParser_AddElements(framedata,textframe,"Target_Updated",function(framedata,unitdata)
		local unitdata=unitdata
		local targetguid=unitdata.TargetGUID
		if(targetguid)then
			local targetunitdata=NPA_DataCollector_GetUnitDataByGUID(targetguid)
			if(targetguid==UnitGUID("player"))then
				textframe.Text:SetText(You)
			elseif(targetunitdata)then
				textframe.Text:SetText("=>>"..(targetunitdata.Name or "Unknow").."<<=")
			else
				textframe.Text:SetText("=>>Unknow<<=")
			end
			--color
			ColorFunc(textframe.Text,targetunitdata)
			--show it
			NPA_NamePlateModuleManager_UnzipModule(textframe)
			--set timer, hide after 1s
			NPA_FrameMacro_SetFrameTimer(textframe,unitdata.TargetUpdated,unitdata.TargetUpdated+1,
				function(nTime,data)
					--update alpha
					local percent=(data.EndTime-nTime)/data.Length
					textframe:SetAlpha(setting.Alpha*percent)
				end,
				function()
					--hide when time out
					NPA_NamePlateModuleManager_ZipModule(textframe)
				end)
		else
			NPA_NamePlateModuleManager_ZipModule(textframe)
		end
	end)
	--register show/hide control
	--placeholder
end)
--
NPA.NamePlateModuleManager.RegisterDataModule("TextureGroup","Target",function(framedata,textureframe,setting)
	--zip it first
	NPA_NamePlateModuleManager_ZipModule(textureframe)
	--add event elements
	NPA_NamePlateDataParser_AddElements(framedata,textureframe,"ModuleMain_OnUpdate",function(framedata)
		local unitdata=unitdata
		--endtime==nil means casting is ended
		if(UnitExists("target") and framedata.GUID==UnitGUID("target"))then
			--show it
			NPA_NamePlateModuleManager_UnzipModule(textureframe)
		else
			NPA_NamePlateModuleManager_ZipModule(textureframe)
		end
	end)
end)